com.fasterxml.jackson.core.util

## Class MinimalPrettyPrinter

- java.lang.Object
- - com.fasterxml.jackson.core.util.MinimalPrettyPrinter

All Implemented Interfaces:
  PrettyPrinter, Serializable

    public class MinimalPrettyPrinter
    extends Object
    implements PrettyPrinter, Serializable

`PrettyPrinter` implementation that adds no indentation, just implements everything necessary for value output to work as expected, and provide simpler extension points to allow for creating simple custom implementations that add specific decoration or overrides. Since behavior then is very similar to using no pretty printer at all, usually sub-classes are used.

Beyond purely minimal implementation, there is limited amount of configurability which may be useful for actual use: for example, it is possible to redefine separator used between root-level values (default is single space; can be changed to line-feed).

Note: does NOT implement `Instantiatable` since this is a stateless implementation; that is, a single instance can be shared between threads.

See Also:
  Serialized Form

### Field Summary

Fields
`protected String` `_rootValueSeparator`
`protected Separators` `_separators`

### Fields inherited from interface com.fasterxml.jackson.core.PrettyPrinter

`DEFAULT_ROOT_VALUE_SEPARATOR, DEFAULT_SEPARATORS`

### Constructor Summary

Constructors
Constructor and Description
`MinimalPrettyPrinter()`
`MinimalPrettyPrinter(String rootValueSeparator)`

### Method Summary

Methods
`void` `beforeArrayValues(JsonGenerator g)` Method called after array start marker has been output, and right before the first value is to be output.
`void` `beforeObjectEntries(JsonGenerator g)` Method called after object start marker has been output, and right before the field name of the first entry is to be output.
`void` `setRootValueSeparator(String sep)`
`MinimalPrettyPrinter` `setSeparators(Separators separators)`
`void` `writeArrayValueSeparator(JsonGenerator g)` Method called after an array value has been completely output, and before another value is to be output.
`void` `writeEndArray(JsonGenerator g, int nrOfValues)` Method called after an Array value has been completely output (minus closing bracket).
`void` `writeEndObject(JsonGenerator g, int nrOfEntries)` Method called after an Object value has been completely output (minus closing curly bracket).
`void` `writeObjectEntrySeparator(JsonGenerator g)` Method called after an object entry (field:value) has been completely output, and before another value is to be output.
`void` `writeObjectFieldValueSeparator(JsonGenerator g)` Method called after an object field has been output, but before the value is output.
`void` `writeRootValueSeparator(JsonGenerator g)` Method called after a root-level value has been completely output, and before another value is to be output.
`void` `writeStartArray(JsonGenerator g)` Method called when an Array value is to be output, before any member/child values are output.
`void` `writeStartObject(JsonGenerator g)` Method called when an Object value is to be output, before any fields are output.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _rootValueSeparator

    protected String _rootValueSeparator

#### _separators

    protected Separators _separators

Since:
  2.9

### Constructor Detail

#### MinimalPrettyPrinter

    public MinimalPrettyPrinter()

#### MinimalPrettyPrinter

    public MinimalPrettyPrinter(String rootValueSeparator)

### Method Detail

#### setRootValueSeparator

    public void setRootValueSeparator(String sep)

#### setSeparators

    public MinimalPrettyPrinter setSeparators(Separators separators)

Since:
  2.9

#### writeRootValueSeparator

    public void writeRootValueSeparator(JsonGenerator g)
                                 throws IOException

Description copied from interface: `PrettyPrinter`
Method called after a root-level value has been completely output, and before another value is to be output.

Default handling (without pretty-printing) will output a space, to allow values to be parsed correctly. Pretty-printer is to output some other suitable and nice-looking separator (tab(s), space(s), linefeed(s) or any combination thereof).

Specified by:
  `writeRootValueSeparator` in interface `PrettyPrinter`
Throws:
  `IOException`

#### writeStartObject

    public void writeStartObject(JsonGenerator g)
                          throws IOException

Description copied from interface: `PrettyPrinter`
Method called when an Object value is to be output, before any fields are output.

Default handling (without pretty-printing) will output the opening curly bracket. Pretty-printer is to output a curly bracket as well, but can surround that with other (white-space) decoration.

Specified by:
  `writeStartObject` in interface `PrettyPrinter`
Throws:
  `IOException`

#### beforeObjectEntries

    public void beforeObjectEntries(JsonGenerator g)
                             throws IOException

Description copied from interface: `PrettyPrinter`
Method called after object start marker has been output, and right before the field name of the first entry is to be output. It is not called for objects without entries.

Default handling does not output anything, but pretty-printer is free to add any white space decoration.

Specified by:
  `beforeObjectEntries` in interface `PrettyPrinter`
Throws:
  `IOException`

#### writeObjectFieldValueSeparator

    public void writeObjectFieldValueSeparator(JsonGenerator g)
                                        throws IOException

Method called after an object field has been output, but before the value is output.

Default handling will just output a single colon to separate the two, without additional spaces.

Specified by:
  `writeObjectFieldValueSeparator` in interface `PrettyPrinter`
Throws:
  `IOException`

#### writeObjectEntrySeparator

    public void writeObjectEntrySeparator(JsonGenerator g)
                                   throws IOException

Method called after an object entry (field:value) has been completely output, and before another value is to be output.

Default handling (without pretty-printing) will output a single comma to separate the two.

Specified by:
  `writeObjectEntrySeparator` in interface `PrettyPrinter`
Throws:
  `IOException`

#### writeEndObject

    public void writeEndObject(JsonGenerator g,
                      int nrOfEntries)
                        throws IOException

Description copied from interface: `PrettyPrinter`
Method called after an Object value has been completely output (minus closing curly bracket).

Default handling (without pretty-printing) will output the closing curly bracket. Pretty-printer is to output a curly bracket as well, but can surround that with other (white-space) decoration.

Specified by:
  `writeEndObject` in interface `PrettyPrinter`
  `nrOfEntries` - Number of direct members of the array that have been output
Throws:
  `IOException`

#### writeStartArray

    public void writeStartArray(JsonGenerator g)
                         throws IOException

Description copied from interface: `PrettyPrinter`
Method called when an Array value is to be output, before any member/child values are output.

Default handling (without pretty-printing) will output the opening bracket. Pretty-printer is to output a bracket as well, but can surround that with other (white-space) decoration.

Specified by:
  `writeStartArray` in interface `PrettyPrinter`
Throws:
  `IOException`

#### beforeArrayValues

    public void beforeArrayValues(JsonGenerator g)
                           throws IOException

Description copied from interface: `PrettyPrinter`
Method called after array start marker has been output, and right before the first value is to be output. It is not called for arrays with no values.

Default handling does not output anything, but pretty-printer is free to add any white space decoration.

Specified by:
  `beforeArrayValues` in interface `PrettyPrinter`
Throws:
  `IOException`

#### writeArrayValueSeparator

    public void writeArrayValueSeparator(JsonGenerator g)
                                  throws IOException

Method called after an array value has been completely output, and before another value is to be output.

Default handling (without pretty-printing) will output a single comma to separate values.

Specified by:
  `writeArrayValueSeparator` in interface `PrettyPrinter`
Throws:
  `IOException`

#### writeEndArray

    public void writeEndArray(JsonGenerator g,
                     int nrOfValues)
                       throws IOException

Description copied from interface: `PrettyPrinter`
Method called after an Array value has been completely output (minus closing bracket).

Default handling (without pretty-printing) will output the closing bracket. Pretty-printer is to output a bracket as well, but can surround that with other (white-space) decoration.

Specified by:
  `writeEndArray` in interface `PrettyPrinter`
  `nrOfValues` - Number of direct members of the array that have been output
Throws:
  `IOException`